#
# spec file for package perl-MooseX-Storage
#
# Copyright (c) 2025 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%define cpan_name MooseX-Storage
Name:           perl-MooseX-Storage
Version:        0.530.0
Release:        1.1
# 0.53 -> normalize -> 0.530.0
%define cpan_version 0.53
#Upstream: Artistic-1.0 or GPL-1.0-or-later
License:        Artistic-1.0 OR GPL-1.0-or-later
Summary:        Serialization framework for Moose classes
URL:            https://metacpan.org/release/%{cpan_name}
Source0:        https://cpan.metacpan.org/authors/id/E/ET/ETHER/%{cpan_name}-%{cpan_version}.tar.gz
Source1:        cpanspec.yml
BuildArch:      noarch
BuildRequires:  perl
BuildRequires:  perl-macros
BuildRequires:  perl(CPAN::Meta::Requirements) >= 2.121
BuildRequires:  perl(IO::AtomicFile)
BuildRequires:  perl(JSON::MaybeXS) >= 1.1
BuildRequires:  perl(JSON::PP)
BuildRequires:  perl(Module::Metadata)
BuildRequires:  perl(Module::Runtime)
BuildRequires:  perl(Moose) >= 0.990
BuildRequires:  perl(Moose::Meta::Attribute)
BuildRequires:  perl(Moose::Role)
BuildRequires:  perl(Moose::Util::TypeConstraints)
BuildRequires:  perl(String::RewritePrefix)
BuildRequires:  perl(Test::Deep)
BuildRequires:  perl(Test::Deep::JSON)
BuildRequires:  perl(Test::Deep::Type)
BuildRequires:  perl(Test::Fatal)
BuildRequires:  perl(Test::More) >= 0.88
BuildRequires:  perl(Test::Needs)
BuildRequires:  perl(Test::Without::Module)
BuildRequires:  perl(YAML::Any)
BuildRequires:  perl(namespace::autoclean)
Requires:       perl(IO::AtomicFile)
Requires:       perl(JSON::MaybeXS) >= 1.1
Requires:       perl(Module::Runtime)
Requires:       perl(Moose) >= 0.990
Requires:       perl(Moose::Meta::Attribute)
Requires:       perl(Moose::Role)
Requires:       perl(String::RewritePrefix)
Requires:       perl(YAML::Any)
Requires:       perl(namespace::autoclean)
Provides:       perl(MooseX::Storage) = %{version}
Provides:       perl(MooseX::Storage::Base::WithChecksum) = %{version}
Provides:       perl(MooseX::Storage::Basic) = %{version}
Provides:       perl(MooseX::Storage::Deferred) = %{version}
Provides:       perl(MooseX::Storage::Engine) = %{version}
Provides:       perl(MooseX::Storage::Engine::IO::AtomicFile) = %{version}
Provides:       perl(MooseX::Storage::Engine::IO::File) = %{version}
Provides:       perl(MooseX::Storage::Engine::Trait::DisableCycleDetection) = %{version}
Provides:       perl(MooseX::Storage::Engine::Trait::OnlyWhenBuilt) = %{version}
Provides:       perl(MooseX::Storage::Format::JSON) = %{version}
Provides:       perl(MooseX::Storage::Format::Storable) = %{version}
Provides:       perl(MooseX::Storage::Format::YAML) = %{version}
Provides:       perl(MooseX::Storage::IO::AtomicFile) = %{version}
Provides:       perl(MooseX::Storage::IO::File) = %{version}
Provides:       perl(MooseX::Storage::IO::StorableFile) = %{version}
Provides:       perl(MooseX::Storage::Meta::Attribute::DoNotSerialize) = %{version}
Provides:       perl(MooseX::Storage::Meta::Attribute::Trait::DoNotSerialize) = %{version}
Provides:       perl(MooseX::Storage::Traits::DisableCycleDetection) = %{version}
Provides:       perl(MooseX::Storage::Traits::OnlyWhenBuilt) = %{version}
Provides:       perl(MooseX::Storage::Util) = %{version}
%undefine       __perllib_provides
Recommends:     perl(IO::AtomicFile)
Recommends:     perl(JSON::MaybeXS) >= 1.1
Recommends:     perl(YAML)
Recommends:     perl(YAML::Any)
Recommends:     perl(YAML::Syck)
Recommends:     perl(YAML::XS)
%{perl_requires}

%description
MooseX::Storage is a serialization framework for Moose, it provides a very
flexible and highly pluggable way to serialize Moose classes to a number of
different formats and styles.

%prep
%autosetup -n %{cpan_name}-%{cpan_version} -p1

%build
perl Makefile.PL INSTALLDIRS=vendor
%make_build

%check
make test

%install
%perl_make_install
%perl_process_packlist
%perl_gen_filelist

%files -f %{name}.files
%doc Changes CONTRIBUTING README
%license LICENSE

%changelog
* Mon Jun 23 2025 Tina Müller <tina.mueller@suse.com>
- Normalize CPAN version
  See https://github.com/openSUSE/cpanspec/issues/47 for details
* Sun Apr 19 2020 <timueller+perl@suse.de>
- updated to 0.53
  see /usr/share/doc/packages/perl-MooseX-Storage/Changes
  0.53      2020-04-18 03:46:55Z
  - minor prerequisite improvements
* Sat Oct  8 2016 coolo@suse.com
- updated to 0.52
  see /usr/share/doc/packages/perl-MooseX-Storage/Changes
  0.52      2016-06-22 03:22:12Z
  - when looking for a serializer for a type constraint, always use the
    user-defined type handler first, before recursing into parent types
  0.51      2016-02-10 20:06:41Z (TRIAL RELEASE)
  - support serialization of "maybe" types created by MooseX::Types (PR#12)
  0.50      2015-05-05 20:09:42Z
  - revert changes in 0.49 for deeply-nested objects (see RT#104106)
* Tue Apr 14 2015 coolo@suse.com
- updated to 0.49
  see /usr/share/doc/packages/perl-MooseX-Storage/Changes
  0.49      2015-03-29 00:24:43Z
  - now handling more deeply-nested objects (PR#7, RT#81236, thanks Dmitry
    Latin!)
  - fix error in DateTime example (PR#8, thanks sillitoe!)
  0.48      2014-10-12 02:01:31Z
  - switched the JSON serializer from JSON::Any to JSON::MaybeXS
  - interactive prompting at install time is now back!
  0.47      2014-08-23 22:34:21Z
  - report the versions of all JSON and YAML backends during tests, in an
    attempt to track down an elusive bug
  - now properly serializing attributes that are set to the undefined value
    (github #6, thanks, Jason Pope!)
  - fix compatibility problem with MooseX::Role::Parameterized 1.03+ and
    MooseX::Storage::Format::JSONpm (some internal details changed that we
    were relying on)
  0.46      2014-03-23 18:26:44Z
  - numerous small documentation clarifications and fixes
* Sat Mar 15 2014 coolo@suse.com
- updated to 0.45
  - re-release to fix compile test
  - removed use of deprecated Class::MOP::load_class
  - all features are now configured as x_default => 1 in metadata (not yet
    supported by any cpan clients), signalling to automatically add to prereqs
    when installing non-interactively
  - re-release with properly encoded META.yml
  - re-release with updated Dist::Zilla plugins to clear the dynamic_config
    flag in metadata
  - repository has moved to the GitHub Moose organization
  - replaced last use of Best (held over since 2010!) to YAML::Any
  - fixed another test making use of optional features
  - re-release with new compile test, which properly declares all its prerequisites
  - fixed compile tests so that modules using optional features are skipped
    (from 0.36-TRIAL)
  - convert to Dist::Zilla, with new optional prereq handling
* Sun Dec 25 2011 coolo@suse.com
- update to 0.30
  * Make Makefile.PL features work again. RT#67170
  * Remove use of Test::TempDir in favor of File::Temp (gphat)
  * Make the engine_traits parameter be able to use a '+My::Trait::Name'
    prefix to specify a trait name which isn't in the
    MooseX::Storage::Engine::Trait namespace
  * Misc POD and test cleanups.
* Wed Dec  1 2010 coolo@novell.com
- switch to perl_requires macro
* Mon Nov 29 2010 coolo@novell.com
- remove /var/adm/perl-modules
* Sun Jul 25 2010 pascal.bleser@opensuse.org
- initial package (0.27)
